## Script (Python) "bibnotes_get_data"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Glue code that stuffs field information into a map
##

#
# Here is the structure we return:
#
#     fieldname
#       accessor
#       field
#       widget
#       mode
#       value
#     ...
#
# This script is in serious need of a mop and broom


from Products.CMFCore.utils import getToolByName
top = getToolByName(context,'bibnotes_data')

REQUEST = context.REQUEST
stub = REQUEST.get('bibnotes_stub')

# No stub will exist if run from view
if not stub:
    from AccessControl import getSecurityManager
    username = getSecurityManager().getUser().getUserName()
    uid = context.UID()

    userfolder = top.restrictedTraverse(username)
    
    if userfolder.has_key(uid):
	obj = userfolder.restrictedTraverse(uid)
    else:
	ret = {'annotation':{'value':''}}
	return ret

else:
    obj = top.restrictedTraverse(stub)


ret = {}
schema = obj.Schema()
fields = schema.fields()
for field in fields:
    fieldName = field.getName()
    if not fieldName in ('annotation','bibnotesRecommend','bibnotesToRead'):
	continue
    edit_accessor = field.getEditAccessor(schema)
    accessor = field.getAccessor(schema)
    widget = field.widget
    getMethod = (widget.populate and (edit_accessor or accessor)) or None
    value = getMethod and getMethod()
    value = widget.postback and REQUEST.get(fieldName, obj.session_restore_value(fieldName, value)) or value

    ret[fieldName] = {}
    ret[fieldName]['accessor'] = accessor
    ret[fieldName]['edit_accessor'] = edit_accessor
    ret[fieldName]['field'] = field
    ret[fieldName]['widget'] = field.widget
    ret[fieldName]['mode'] = field.mode
    ret[fieldName]['value'] = value

return ret
