## Controller Python Script "bibnotes_purgeOrphans"
##bind container=container
##bind context=context
##bind namespace=
##bind state=state
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Delete notes with no available target object

from Products.CMFCore.utils import getToolByName

bibnotes_tool = getToolByName(context,'bibnotes_tool')

deletes = bibnotes_tool.purge_orphans()

if len(deletes) > 1:
  s = 's'
else:
  s = ''

if deletes:
   state.set(status='success',
             portal_status_message='Purged %d orphan%s.' % (len(deletes),s))
else:
   state.set(status='success',
   portal_status_message='No orphans found, none purged.')

from Products.Archetypes import transaction_note
transaction_note('Deleted %d orphans of type BibNote, with ids: %s' % (len(deletes),', '.join(deletes)))
    
return state
