# File: BibNotesTool.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.4.1
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.BibNotes.config import *


from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName
from Products.BibNotes.interfaces.tool import IBibNotesTool
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

BibNotesTool_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BibNotesTool(UniqueObject, BaseContent):
    security = ClassSecurityInfo()
    ifaces = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)
    __implements__ = ifaces + (IBibNotesTool,)

    # This name appears in the 'add' box
    archetype_name = 'BibNotesTool'

    meta_type = 'BibNotesTool'
    portal_type = 'BibNotesTool'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    allow_discussion = False
    #content_icon = 'BibNotesTool.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "BibNotesTool"
    typeDescMsgId = 'description_edit_bibnotestool'
    toolicon = 'tool.gif'

    schema = BibNotesTool_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'bibnotes_tool')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer


    # Methods
    security.declareProtected(CMFCorePermissions.ManagePortal,'purge_orphans')
    def purge_orphans(self,ref_uid=''):
	
	pb = getToolByName(self,'portal_bibliography')
	reference_types = pb.getReferenceTypes()

	zcat = getToolByName(self,'portal_catalog')

	root = getToolByName(self,'portal_url').getPortalObject()
	rootpath = '/'.join(root.getPhysicalPath())
	datapath = '%s/bibnotes_data' % (rootpath,)

	lazylist = zcat(path=datapath,
	                portal_type='BibNote',
			bibnotesRefUID=ref_uid)
			
	deletes = []
	for lazy in lazylist:
	    res = zcat(portal_type=reference_types,
	               bibnotesRefUID=lazy.getId)
	    if not res:
		obj = lazy.getObject()
		obj_id = lazy.getId

		parent = obj.aq_parent
		parent_id = parent.getId()

		obj.unindexObject()
		parent.manage_delObjects([obj_id])

		deletes.append('%s/%s' % (parent_id,obj_id))
	
	return deletes
	

registerType(BibNotesTool,PROJECTNAME)
# end of class BibNotesTool

##code-section module-footer #fill in your manual code here
##/code-section module-footer



